using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

enum NpcState {
    Idle,
    Patrolling
}

public class Patrolling : MonoBehaviour
{
    float nextSwitchTime;
    NpcState currentState;
    float animTime;

    float SPEED = 1; // unit / sec 
    Vector3 direction;

    // Start is called before the first frame update
    void Start()
    {
        nextSwitchTime = 0;
        currentState = NpcState.Idle;
        animTime = 0;
        direction = new Vector3();
    }

    void FindNewTarget()
    {
        System.Random rand = new System.Random();
        float x = (float)rand.NextDouble() * 4.0f - 2.0f;
        float z = (float)rand.NextDouble() * 4.0f - 2.0f;
        Vector3 targetPosition = new Vector3(x, 2.0f, z);
        GameObject.Find("Cylinder").transform.position = targetPosition;
        direction = Vector3.Normalize(targetPosition - transform.position);
        Debug.Log(targetPosition);
    }

    float CalcTravelTime()
    {
        Vector3 targetPos = GameObject.Find("Cylinder").transform.position;
        float distance = Vector3.Distance(transform.position, targetPos);
        float travelTime = distance / SPEED;
        return travelTime;
    }

    // Update is called once per frame
    void Update()
    {
        if (currentState == NpcState.Patrolling) {
            /*
            transform.position = new Vector3(
                2.0f * (float)Math.Sin(animTime),
                1.25f,
                0f
            );
            animTime += Time.deltaTime;
            */            
            // GameObject.Find("Cylinder").transform.position = transform.position;
            transform.position += direction * Time.deltaTime;
        }
        // Debug.Log(Time.fixedTime);
        if (Time.fixedTime > nextSwitchTime) {
            if (currentState == NpcState.Idle) {
                currentState = NpcState.Patrolling;
                FindNewTarget();
                nextSwitchTime += CalcTravelTime();
            } else {
                currentState = NpcState.Idle;
                nextSwitchTime += 3;
            }
        }
    }
}
